function map = hashadd(map,key,val)
% map = hashadd(map,key,val)
% adds a 'key' -> val binding to the hashtable map.
% Tue Sep 28 14:00:49 JST 2004 dmochiha@slt.atr.jp
% $Id: hashadd.m,v 1.3 2004/09/30 05:42:38 dmochiha Exp $
n = map.size;
h = hash(key,n);
h2 = hash2(key);

for i = 1:n
  if (map.val(h+1) == 0) % empty location found!
    map.key{h+1} = key;
    map.val(h+1) = val;
    map.nnz = map.nnz + 1;
    if map_crowded(map.nnz,map.size)
      map = hashgrow(map);
    end
    return;
  elseif strcmp(key,map.key{h+1}) % check for already existed
    map.val(h+1) = val;
    return;
  end
  h = mod(h + 2 * h2 + 1,n);
end

% hash resizer
function newmap = hashgrow(map)
n = map.size;
newmap = hashinit(n * 2);
for i = 1:n
  if (map.val(i) ~= 0)
    newmap = hashadd(newmap,map.key{i},map.val(i));
  end
end

% hash function and utility
function h = hash(key,n)
h = 0;
for c = key
  h = mod(h * 33 + c,n);
end

function h2 = hash2(key)
k = 3; % first max 3 chars
l = min(k,size(key,2));
h2 = 7 - mod(sum(key(1:l)+0),8);

function z = map_crowded(m,n)
z = (m > 7 / 8 * n);

% end of file.
