function map = hashadds(map,keys,vals)
% map = hashadds(map,keys,vals)
% adds 'key' -> val binding pairs to the hashtable map.
% Wed Sep 29 14:22:54 JST 2004 dmochiha@slt.atr.jp
% $Id: hashadds.m,v 1.2 2004/09/30 05:42:39 dmochiha Exp $
n = map.size;
k = size(keys,2);
if (size(keys,2) ~= size(vals,2))
  error('hashadds: size of keys and vals are not equal.');
end

for i = 1:k
  key = keys{i};
  val = vals(i);
  h = hash(key,n);
  h2 = hash2(key);
  fprintf(1,'adding key %d/%d..\r',i,k);
  for j = 1:n
    if (map.val(h+1) == 0) % empty location found!
      map.key{h+1} = key;
      map.val(h+1) = val;
      map.nnz = map.nnz + 1;
      if map_crowded(map.nnz,map.size)
	map = hashgrow(map);
      end
      break;
    elseif strcmp(key,map.key{h+1}) % check for already existed
      map.val(h+1) = val;
      break;
    end
    h = mod(h + 2 * h2 + 1,n);
  end
end
fprintf(1,'\ndone.\n');

% hash resizer
function newmap = hashgrow(map)
n = map.size;
newmap = hashinit(n * 2);
for i = 1:n
  if (map.val(i) ~= 0)
    fprintf(1,'growing %d/%d..\r',i,n);
    newmap = hashadd(newmap,map.key{i},map.val(i));
  end
end

% hash function and utility
function h = hash(key,n)
h = 0;
for c = key
  h = mod(h * 33 + c,n);
end

function h2 = hash2(key)
k = 3; % first max 3 chars
l = min(k,size(key,2));
h2 = 7 - mod(sum(key(1:l)+0),8);

function z = map_crowded(m,n)
z = (m > 7 / 8 * n);

% end of file.
